# -*- coding:Utf-8 -*-
# dm_python V1.003p (31/07/2008) by DoCky


import es, psyco, re, os.path, cPickle, random, popuplib, playerlib, gamethread
psyco.full()


class File:
    """
        File reader
    """

    def __init__(self):
        self._line = []

    def __loop(self):
        indx = 0
        while indx < len(self._line):
            self._line[indx] = re.sub('//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\t)+|(\n)+|(")+|', "", self._line[indx])

            if not self._line[indx]:
                del(self._line[indx])
            else:
                indx += 1

    def read(self, P):
        try:
            self._line = []
            line = open(P, "r")
            self._line = line.readlines()
            self.__loop()

        finally:
            line.close()
            return self._line[:]

class Menu:
    """
        Create menu
    """

    def __init__(self):
        self._menu = {}
        self._item = {}
        if not es.exists("clientcommand", "!dm"):
            es.regclientcmd("!dm", "dm_python/player_cmd", "dm_python menu acces")

    def __name(self, I):
        name = popuplib.active(I)["name"]
        if name != "0":
            popuplib.unsendname(name, I)

    def __menu(self, I, C, N):
        self.unsend(0, I)
        if C == 1:
            self.unsend(1, I)
        elif C == 2:
            _user.arms(es.getplayersteamid(I), I)

    def __user(self, I, C, N):
        """ """

    def __arms(self, I, C, N):
        self.unsend(0, I)
        if C in self._menu["arm"]:
            self.unsend(1, I)

        elif C == 9:
            self.unsend(1, I)
            if not es.getplayersteamid(I) in str(_cvar[2]):
                popuplib.send("dp_dpm", I)
            else:
                popuplib.send("dp_dpa", I)

    def __give(self, I, C, N):
        self.unsend(0, I)
        if C in self._item[N]:
            self.unsend(1, I)
            unid = es.getplayersteamid(I)
            if N == "dp_gun":
                _user._data[unid][1] = self._item[N][C]
                _user.give(unid, I, 0, 1)

            else:
                _user._data[unid][0] = self._item[N][C]
                _user.give(unid, I, 1, 0)

        elif C == 9:
            self.unsend(1, I)

    def create(self):
        self._menu = {
            "gun" : ["glock", "usp", "p228", "deagle", "fiveseven", "elite"],
            "pmp" : ["m3", "xm1014"],
            "pms" : ["tmp", "mac10", "mp5navy", "ump45", "p90"],
            "rif" : ["galil", "famas", "ak47", "m4a1", "sg552", "aug", "m249"],
            "snp" : ["scout", "awp", "g3sg1", "sg550"]
            }

        for sect, item in self._menu.items():
            I = 0
            while I != len(item):
                if item[I] in _rest:
                    del(item[I])
                else:
                    I += 1

        self._menu["dpm"] = None
        self._menu["arm"] = []

        M = popuplib.create("dp_dpm")
        M.addline("DEATHMATCH")
        M.addline("->1. Get new weapons")
        M.addline("->2. Save current weapons")
        M.addline("Access menu : !dm")
        M.addline("0. Exit")
        M.submenu(1, "dp_arm")
        M.menuselect = self.__menu

        M = popuplib.create("dp_dpa")
        M.addline("DEATHMATCH")
        M.addline("->1. Get new weapons")
        M.addline("->2. Save current weapons")
        M.addline("->3. Deathmach administration")
        M.addline("Access menu : !dm")
        M.addline("0. Exit")
        M.submenu(1, "dp_arm")
        M.submenu(3, "dp_adm")
        M.menuselect = self.__menu

        M = popuplib.create("dp_adm")
        M.addline("ADMINISTRATION")
        M.addline(" ")
        M.addline("Soon")
        M.addline(" ")
        M.addline("9. Back")
        M.addline("0. Exit")
        M.submenu(9, "dp_dpa")
        M.menuselect = self.__user

        M = popuplib.create("dp_arm")
        M.addline("Choose category :")
        M.menuselect = self.__arms
        S = 0

        for sect in ["gun", "pmp", "pms", "rif", "snp"]:
            if len(self._menu[sect]):
                I = 0
                S += 1
                self._menu["arm"].append(S)
                self._item["dp_%s" % sect] = {}

                M.addline("->%s. %s" % (S, sect))
                M.submenu(S, "dp_%s" % sect)
                W = popuplib.create("dp_%s" % sect)
                W.addline("%s :" % sect)

                while I != len(self._menu[sect]):
                    I += 1
                    W.addline("->%s. %s" % (I, self._menu[sect][I - 1]))
                    W.submenu(I, "dp_arm")
                    self._item["dp_%s" % sect][I] = self._menu[sect][I - 1]

                W.addline("9. Back")
                W.addline("0. Exit")
                W.submenu(9, "dp_arm")
                W.menuselect = self.__give

        M.addline("9. Back")
        M.addline("0. Exit")

    def unsend(self, C, I):
        if C:
            gamethread.delayedname(float(_cvar[4]), "dp_%s" % I, self.__name, I)
        else:
            gamethread.cancelDelayed("dp_%s" % I)

    def delete(self):
        for menu in self._menu:
            if popuplib.exists("dp_%s" % menu):
                popuplib.unsendname("dp_%s" % menu, playerlib.getUseridList("#human,#alive"))
                popuplib.delete("dp_%s" % menu)
        if es.exists("clientcommand", "!dm"):
            es.unregclientcmd("!dm")


class User:
    """
        Player management
    """

    def __init__(self):
        self._path = es.getAddonPath(dp_info.name) + "/dm_data/data.dp"
        self._data = {}
        self._user = {}

    def save(self):
        cPickle.dump(self._data, open(self._path, "w"))

    def load(self):
        if not os.path.isfile(self._path):
            self.save()
        self._data = cPickle.load(open(self._path, "r"))

    def data(self, U):
        if not self._data.has_key(U):
            self._data[U] = ["m4a1", "deagle"]

    def arms(self, U, I):
        user = playerlib.getPlayer(I)
        self._data[U] = [user.get("primary"), user.get("secondary")]

    def user(self, I):
        self._user[I] = [int(_cvar[6]), int(_cvar[7]), int(_cvar[8]), int(_cvar[9]), int(_cvar[10])]

    def give(self, U, I, P, S):
        user = playerlib.getPlayer(I)
        if P and self._data[U][0] != "0":
            name = user.get("primary")
            if name != self._data[U][0]:
                if name != "0":
                    es.server.queuecmd("es_xremove %s" % user.get("weaponindex", name))
                es.server.queuecmd("es_xgive %s weapon_%s" % (I, self._data[U][0]))

        if S and self._data[U][1] != "0":
            name = user.get("secondary")
            if name != self._data[U][1]:
                if name != "0":
                    es.server.queuecmd("es_xremove %s" % user.get("weaponindex", name))
                es.server.queuecmd("es_xgive %s weapon_%s" % (I, self._data[U][1]))

        if self._user[I][3] == 1:
            es.setplayerprop(I, "CCSPlayer.m_bHasNightVision", 1)

        if self._user[I][4] == 1:
            es.setplayerprop(I, "CCSPlayer.m_bHasDefuser", 1)

        for nade in [0, 1, 2]:
            self.nade(nade, I)

    def nade(self, N, I):
        if not N:
            if self._user[I][0] > 0:
                if not playerlib.getPlayer(I).get("he"):
                    self._user[I][0] -= 1
                    es.server.queuecmd("es_xgive %s weapon_hegrenade" % I)

        elif not N:
            if self._user[I][1] > 0:
                if not playerlib.getPlayer(I).get("fb"):
                    self._user[I][1] -= 1
                    es.server.queuecmd("es_xgive %s weapon_flashbang" % I)

        elif not N:
            if self._user[I][2] > 0:
                if not playerlib.getPlayer(I).get("sg"):
                    self._user[I][2] -= 1
                    es.server.queuecmd("es_xgive %s weapon_smokegrenade" % I)

    class Bot:
        """
            Bot management
        """

        def __init__(self):
            self._user = {}
            self._item = [
                ["m3", "xm1014",
                "tmp", "mac10", "mp5navy", "ump45", "p90",
                "galil", "famas", "ak47", "m4a1", "sg552", "aug", "m249",
                "scout", "awp", "g3sg1", "sg550"],
                ["glock", "usp", "p228", "deagle", "fiveseven", "elite"]
                ]

            for item in self._item:
                indx = 0
                while indx != len(item):
                    if item[indx] in _rest:
                        del(item[indx])
                    else:
                        indx += 1

            if str(_cvar[11]) and _cvar[11] != "0":
                arms = []
                for name in str(_cvar[11]).split(","):
                    if name in self._item[0]:
                        arms.append(name)
                self._item[0] = arms

            if str(_cvar[12]) and _cvar[12] != "0":
                arms = []
                for name in str(_cvar[12]).split(","):
                    if name in self._item[1]:
                        arms.append(name)
                self._item[1] = arms

        def user(self, I):
            self._user[I] = [int(_cvar[13]), int(_cvar[14]), int(_cvar[15]), int(_cvar[16]), int(_cvar[17])]

        def give(self, I):
            user = playerlib.getPlayer(I)
            name = user.get("primary")
            rand = self._item[0][random.randint(0, len(self._item[0]) - 1)]
            if name != rand:
                if name != "0":
                    es.server.queuecmd("es_xremove %s" % user.get("weaponindex", name))
                es.server.queuecmd("es_xgive %s weapon_%s" % (I, rand))

            name = user.get("secondary")
            rand = self._item[1][random.randint(0, len(self._item[1]) - 1)]
            if name != rand:
                if name != "0":
                    es.server.queuecmd("es_xremove %s" % user.get("weaponindex", name))
                es.server.queuecmd("es_xgive %s weapon_%s" % (I, rand))

            if self._user[I][3] == 1:
                es.setplayerprop(I, "CCSPlayer.m_bHasNightVision", 1)

            if self._user[I][4] == 1:
                es.setplayerprop(I, "CCSPlayer.m_bHasDefuser", 1)

            for nade in [0, 1, 2]:
                self.nade(nade, str(I))

        def nade(self, N, I):
            if not N:
                if self._user[I][0] > 0:
                    if not playerlib.getPlayer(I).get("he"):
                        self._user[I][0] -= 1
                        es.server.queuecmd("es_xgive %s weapon_hegrenade" % I)

            elif not N:
                if self._user[I][1] > 0:
                    if not playerlib.getPlayer(I).get("fb"):
                        self._user[I][1] -= 1
                        es.server.queuecmd("es_xgive %s weapon_flashbang" % I)

            elif not N:
                if self._user[I][2] > 0:
                    if not playerlib.getPlayer(I).get("sg"):
                        self._user[I][2] -= 1
                        es.server.queuecmd("es_xgive %s weapon_smokegrenade" % I)


dp_info = es.AddonInfo()
dp_info.version = "1.003p"
dp_info.author = "DoCky"
dp_info.name = "dm_python"
dp_info.url = "http://addons.eventscripts.com/addons/user/11751"
dp_path = es.ServerVar("eventscripts_gamedir") + "/cfg/dm_python/"

_cvar = [
    es.ServerVar(dp_info.name, "", "Created by DoCky -"),
    es.ServerVar("dp_langage", "", "[dm_python] script langage"),
    es.ServerVar("dp_steamid", "", "[dm_python] administrator"),
    es.ServerVar("dp_killmax", "", "[dm_python] kill max"),
    es.ServerVar("dp_timeout", "", "[dm_python] menu timeout"),
    es.ServerVar("dp_mission", "", "[dm_python] remove objectif"),

    es.ServerVar("dp_player_hegrenade", "", "[dm_python] grenade max"),
    es.ServerVar("dp_player_flashbang", "", "[dm_python] flashbang max"),
    es.ServerVar("dp_player_smokegrenade", "", "[dm_python] smokegrenade max"),
    es.ServerVar("dp_player_nightvision", "", "[dm_python] give nightvision"),
    es.ServerVar("dp_player_defusekit", "", "[dm_python] give defuse kit"),

    es.ServerVar("dp_bot_primary", "", "[dm_python] bot primary weapon"),
    es.ServerVar("dp_bot_secondary", "", "[dm_python] bot secodary weapon"),
    es.ServerVar("dp_bot_hegrenade", "", "[dm_python] bot grenade max"),
    es.ServerVar("dp_bot_flashbang", "", "[dm_python] bot flashbang max"),
    es.ServerVar("dp_bot_smokegrenade", "", "[dm_python] bot smokegrenade max"),
    es.ServerVar("dp_bot_nightvision", "", "[dm_python] give bot nightvision"),
    es.ServerVar("dp_bot_defusekit", "", "[dm_python] give bot defuse kit"),
    ]

_cvar[0].set(dp_info.version)
_cvar[0].makepublic()
_file = File()
_menu = Menu()
_user = User()


def init():
    global _rest, _botm
    es.server.cmd("es_xmexec dm_python/config.cfg")
    _rest = _file.read(dp_path + "weapon.cfg")
    _botm = _user.Bot()
    _menu.create()
    _user.load()

    for user in playerlib.getUseridList("#human,#alive"):
        unid = es.getplayersteamid(user)
        if unid != "STEAM_ID_PENDING":
            _user.user(unid)
            player_chk(unid, user)

    gamethread.delayed(1, remove_entity)
    gamethread.delayed(1, es.forcevalue, ("mp_fraglimit", _cvar[3]))

def unload():
    _user.save()
    _menu.delete()

def load():
    init()

def es_map_start(E):
    _user.save()
    init()

def remove_entity():
    enti = es.createentitylist()
    for indx in enti:
        if enti[indx]["classname"].startswith("weapon_"):
            if es.getindexprop(indx, "CBaseCombatWeapon.m_hOwner") == -1:
                es.server.queuecmd("es_xremove %s" % indx)

    for user in playerlib.getUseridList("#all"):
        es.server.queuecmd("est_deleteragdolls %s" % user)
    gamethread.delayed(15, remove_entity)

def remove_mission():
    es.server.queuecmd("es_xremove weapon_c4")
    for indx in es.createentitylist("hostage_entity"):
        es.server.queuecmd("es_xremove %s" % indx)

def round_start(E):
    if not int(_cvar[5]):
        remove_mission()

def player_cmd():
    user = es.getcmduserid()
    player_chk(es.getplayersteamid(user), user)

def player_say(E):
    if E["text"] == "!dm":
        player_chk(E["es_steamid"], E["userid"])

def player_chk(U, I):
    if U == "STEAM_ID_PENDING":
        es.tell(I, "#multi", "#green[#defaultdm_python#green]#default Can't add your steamid")
    else:
        if es.getplayerprop(I, "CBasePlayer.pl.deadflag"):
            es.server.queuecmd("est_spawn %s 0" % I)

        _user.data(U)
        _menu.unsend(1, I)
        name = popuplib.active(I)["name"]
        if name != "0":
            popuplib.close(name, I)
        if not U in str(_cvar[2]):
            popuplib.send("dp_dpm", I)

        else:
            popuplib.send("dp_dpa", I)

def player_death(E):
    gamethread.delayed(1, es.server.queuecmd, "est_spawn %s 0" % E["userid"])

def player_spawn(E):
    if not es.getplayerprop(E["userid"], "CBasePlayer.pl.deadflag") and E["es_steamid"] != "STEAM_ID_PENDING":
        es.server.queuecmd("es_xgive %s item_assaultsuit" % E["userid"])
        es.setplayerprop(E["userid"], "CBasePlayer.m_lifeState", 0)
        es.setplayerprop(E["userid"], "CBaseEntity.m_CollisionGroup", 2)
        gamethread.delayed(1, es.setplayerprop, (E["userid"], "CBasePlayer.m_lifeState", 512))
        gamethread.delayed(2, es.setplayerprop, (E["userid"], "CBaseEntity.m_CollisionGroup", 5))

        if E["es_steamid"] == "BOT":
            _botm.user(E["userid"])
            _botm.give(E["userid"])
        elif _user._data.has_key(E["es_steamid"]):
            _user.user(E["userid"])
            _user.give(E["es_steamid"], E["userid"], 1, 1)

def es_player_validated(E):
    if not _user._data.has_key(E["networkid"]):
        _user.data(E["networkid"])

def player_team(E):
    unid = es.getplayersteamid(E["userid"])
    if E["oldteam"] == "0" and E["team"] > 1 and _user._data.has_key(unid):
        gamethread.delayed(.1, player_chk, (unid, E["userid"]))

def player_disconnect(E):
    es.server.queuecmd("est_deleteragdolls %s" % E["userid"])

def item_pickup(E):
    if E["item"] in _rest:
        es.server.queuecmd("es_xremove %s" % playerlib.getPlayer(E["userid"]).get("weaponindex", E["item"]))
        es.sexec(E["userid"], "use weapon_knife")

def hegrenade_detonate(E):
    if E["es_steamid"] == "BOT":
        _botm.nade(E["userid"], 0)
    else:
        _user.nade(E["userid"], 0)

def flashbang_detonate(E):
    if E["es_steamid"] == "BOT":
        _botm.nade(E["userid"], 1)
    else:
        _user.nade(E["userid"], 1)

def smokegrenade_detonate(E):
    if E["es_steamid"] == "BOT":
        _botm.nade(E["userid"], 2)
    else:
        _user.nade(E["userid"], 2)
